/*==============================================================================
FICHA: Indicador N05 - DL 1153 2023
ELABORACION: OGTI/ OGEI - MINSA - JL
==============================================================================*/
use BD_HISINDICADORES
go

--***************************************************
--				BASES DE DATOS.
--***************************************************
--HIS MINSA 
select id_cita
	, convert(date,periodo) fecha_atencion
	, convert(int,aniomes) aniomes
	, renaes
	, num_doc
	, id_tipitem tipo_dx
	, cod_item  
	, valor_lab
into #his_minsa
from BD_BACKUP_OGEI.dbo.MEF_TramaHisMinsa_202211_20221220 (nolock)
where cod_item='90707'										--SPR
and sw=1
and id_tipedad_reg='A' and convert(int,edad_reg)=1			--Nios de 1 ao. 

--RENAES
select distinct COD_ESTAB renaes,
				UBIGEO ubigeo_inei
into #renaes
from BD_BACKUP_OGEI.dbo.Renaes_20221220 (nolock)
where convert(int,ambito)=1

--***************************************************
--					SINTAXIS
--***************************************************
create table #tabla_reporte
(
ubigeo int,
ao int,
den int,
num int
) 

declare @mes_eval int,
		@ao int

set @mes_eval=11 --<=========== Mes de evaluacin
set @ao=2022 --<============= Ao de evaluacin 

--%%%%%%%%%%%%%%%%
--  DENOMINADOR
--%%%%%%%%%%%%%%%%

--1.Nias/nios de 1 ao del padron nominal
select distinct	convert(int,ubigeo) ubigeo,
				@ao ao,
				total_den den
into #padron_den
from BD_HISINDICADORES.dbo.TBL_DLL153_2023_PadronDMUNI

--%%%%%%%%%%%%%%%%
-- NUMERADOR
--%%%%%%%%%%%%%%%%
--1.Nias/nios menor de 2 aos y mayor de 1 ao, que recibieron 2 dosis de la vacuna SPR con cdigo HIS MINSA.
select renaes, count(*) num
into #padron_num
from #his_minsa 
where year(fecha_atencion)=@ao
and month(fecha_atencion)<=@mes_eval
and cod_item='90707'	
and ( try_convert(int,valor_lab)=2 or valor_lab in ('D2','B2') )
group by renaes
	
--Agregando Ubigeo.
select ubigeo_inei, sum(num) num
into  #padron_num_final
from (
		select a.*, b.ubigeo_inei
		from #padron_num a
		inner join #renaes b on converT(int,a.renaes)=convert(int,b.renaes)
) as t group by ubigeo_inei

--%%%%%%%%%%%%%%%%
--	INDICADOR
--%%%%%%%%%%%%%%%%
insert into #tabla_reporte
select a.*, isnull(b.num,0) num
from #padron_den a
left join #padron_num_final b on converT(int,a.ubigeo)=convert(int,b.ubigeo_inei)

--===================
-- REPORTE
--===================
drop table BD_HISINDICADORES.dbo.DL1153_2023_CG05_CoberturaSarampion

select 
B.diris Diris, CASE 
	WHEN B.DESC_DPTO='LIMA' AND B.DESC_PROV='LIMA' THEN 'LIMA METROPOLITANA'
	WHEN B.DESC_DPTO='LIMA' AND B.DESC_PROV<>'LIMA' THEN 'LIMA PROVINCIAS'
	ELSE B.DESC_DPTO END Departamento
, B.desc_prov Provincia
, B.desc_dist Distrito
, B.Red
, a.*
into BD_HISINDICADORES.dbo.DL1153_2023_CG05_CoberturaSarampion
from #tabla_reporte a
inner join BD_HISINDICADORES.dbo.Maestro_UBIGEO_20200407 b on CONVERT(int,a.ubigeo)=CONVERT(int,b.ubigeo) 

select Diris, Departamento, Provincia, Distrito, Red, ubigeo, ao 
, sum(den) den, sum(num) num
from BD_HISINDICADORES.dbo.DL1153_2023_CG05_CoberturaSarampion
group by Diris, Departamento, Provincia, Distrito, Red, ubigeo, ao 



drop table #his_minsa
drop table #padron_den
drop table #padron_num
drop table #padron_num_final
drop table #renaes
drop table #tabla_reporte
-- =D