﻿/*==============================================================================
FICHA: Indicador N°11 - DL 1153 2023
ELABORACION: OGTI/ OGEI - MINSA - JL
==============================================================================*/
use BD_HISINDICADORES
go

--***************************************************
--				BASES DE DATOS.
--***************************************************
--HIS MINSA 
select 
	convert(date,periodo) fecha_atencion
	, convert(int,renaes) renaes
	, id_tipo_doc
	, num_doc
	, id_tipitem tipo_dx
	, cod_item  
	, valor_lab
into #his_minsa
from BD_BACKUP_OGEI.dbo.MEF_TramaHisMinsa_202211_20221220 (nolock)
where sw=1															--Validacion de tipo y numero de documento
and (convert(int,edad_reg) between 50 and 70) and id_tipedad_reg='A'


--***************************************************
--					SINTAXIS
--***************************************************
declare @mes_eval int,
		@año int 

set @mes_eval=11 --<=========== Mes de evaluación
set @año=2022 --<============= Año de evaluación 

--%%%%%%%%%%%%%%%%
-- DENOOMINADOR
--%%%%%%%%%%%%%%%%
--1. Total de personas de 50 a 70 años identificados con Documento de Identidad atendidos por todas las causas y registrados en el HIS
select distinct renaes, id_tipo_doc, num_doc, den=1
into #dpcan_den
from #his_minsa
where year(fecha_atencion)=@año
and month(fecha_atencion)<=@mes_eval
	
--%%%%%%%%%%%%%%%%
-- NUMERADOR
--%%%%%%%%%%%%%%%%

--1. Personas del denominador a quienes que se les ha entregado el resultado del test de sangre oculta en heces y registradas en el HIS con diagnóstico definitivo, lab A (resultado positivo) o N (resultado negativo) 
select distinct renaes, id_tipo_doc, num_doc, num=1
into #dpcan_num
from #his_minsa
where year(fecha_atencion)=@año
and month(fecha_atencion)<=@mes_eval
and tipo_dx='D'
and cod_item='82270'
and valor_lab in ('N','A')


--%%%%%%%%%%%%%%%%
--	INDICADOR
--%%%%%%%%%%%%%%%%
select @año año, renaes, sum(den) den, sum(num) num
into #tabla_reporte
from (
		select a.*, isnull(b.num,0) num
		from #dpcan_den a
		left join #dpcan_num b on a.renaes=b.renaes and a.id_tipo_doc=b.id_tipo_doc and a.num_doc=b.num_doc
) as t group by renaes 


drop table #dpcan_den
drop table #dpcan_num

--===================
-- REPORTE
--===================
drop table BD_HISINDICADORES.dbo.DL1153_2023_CG11_PersonasTamizajeCancerColon

select 
B.diris Diris, CASE 
	WHEN B.DESC_DPTO='LIMA' AND B.DESC_PROV='LIMA' THEN 'LIMA METROPOLITANA'
	WHEN B.DESC_DPTO='LIMA' AND B.DESC_PROV<>'LIMA' THEN 'LIMA PROVINCIAS'
	ELSE B.DESC_DPTO END Departamento
, B.desc_prov Provincia
, B.desc_dist Distrito
, B.desc_red Red
, b.desc_mred MicroRed
, b.cat_estab
, b.desc_estab eess_nombre
, a.*
into BD_HISINDICADORES.dbo.DL1153_2023_CG11_PersonasTamizajeCancerColon
from #tabla_reporte a
inner join BD_BACKUP_OGEI.dbo.Renaes_20221220 b on convert(int,a.renaes)=convert(int,b.COD_ESTAB)
where b.CAT_ESTAB in ('I-3','I-4','II-1') and convert(int,b.ambito)=1


select * from BD_HISINDICADORES.dbo.DL1153_2023_CG11_PersonasTamizajeCancerColon


drop table #his_minsa
drop table #tabla_reporte
-- =D